> ## Documentation Index
> Fetch the complete documentation index at: https://docs.hologram.io/llms.txt
> Use this file to discover all available pages before exploring further.

# Apply a SIM configuration to one or more SIM cards

> Dispatches a configuration change to the specified SIM cards. Non-admin users may only target SIM cards they can access and configurations allowed by their plan.



## OpenAPI

````yaml /api/1/openapi.yaml post /simcards/configure
openapi: 3.0.0
info:
  title: Hologram REST API v1
  description: >-
    The Hologram HTTP API is a REST-style interface for managing Hologram
    devices, accounts, and cloud data.


    Using the Hologram REST API, you can activate SIMs, get your devices
    approximate location, send SMS to your devices, update a device's usage
    limit, and much more.


    ## Authentication


    Hologram supports **HTTP Basic authentication** using API keys. Simply set
    the username of the request to `apikey`. The password field is the API key
    itself.


    You can find your API key on the Hologram Dashboard under [Account
    Settings](https://dashboard.hologram.io/settings/api).


    Your API key gives you access to your personal account, as well as any
    organizations you are a member of. Make sure you don't store your API key in
    a publicly accessible place like GitHub. If you are a member of multiple
    organizations, many endpoints accept an `orgid` argument to filter for
    devices or other objects within a specific organization.


    You can find your `orgid` by following [this guide from our Help
    Center](https://support.hologram.io/hc/en-us/articles/360035421234-What-is-my-organization-ID-orgid).


    ### Header Example


    ```

    curl --verbose GET \

    'https://dashboard.hologram.io/api/1/users/me' \

    -u apikey:YOUR_API_KEY

    ```


    You can also base64 encode "apikey:YOUR_API_KEY" and include it directly in
    the header.


    ```

    curl --verbose GET \

    'https://dashboard.hologram.io/api/1/users/me' \

    --header "Authorization: Basic BASE64(apikey:YOUR_API_KEY)"

    ```


    ## Requests


    Request bodies can be provided in either JSON or form-urlencoded formats.
    Please note that the examples in this documentation will only display JSON
    bodies.


    ### **JSON body**


    ```

    curl --verbose --request POST \

    --header "Content-Type: application/json" \

    --header "Authorization: Basic BASE64(apikey:YOUR_API_KEY)" \

    --data '{"deviceid": 56668, "body": "Hello device!"}' \

    'https://dashboard.hologram.io/api/1/sms/incoming'

    ```


    ### **form-urlencoded body**


    ```

    curl --verbose --request POST \

    --header "Content-Type: application/x-form-urlencoded" \

    --header "Authorization: Basic BASE64(apikey:YOUR_API_KEY)" \

    --data 'deviceid=56668&body=Hello%20device!' \

    'https://dashboard.hologram.io/api/1/sms/incoming'

    ```


    ## Responses


    All API responses are returned as JSON objects with the following fields:


    * `success` (boolean) - Indicates whether the request was successful.

    * `data` (object or array) - Contains the requested data or information
    about the operation that was performed. Only present when `success` is true.

    * `error` (string) - Information about why the request failed. Only present
    when `success` is false.


    Most GET responses will also include the following fields if a limit is
    included as part of the query string:


    * `limit` (number) - The query limit, some have this value built in and
    others often have a maximum value that the limit can be

    * `size` (number) - The number of values returned by the query

    * `continues` (boolean, optional) - This is only returned if there are more
    values than were returned

    * `links` (array) - Contains information related to the query performed
      * `path` (string) - The API endpoint path
      * `base` (string) - API base URL
      * `next` (string) - URL with query string to get the next results

    Note that all dates and times are returned in UTC.


    ## Rate Limiting


    In order to provide a good quality of service to all of our customers, we
    enforce a rate limit on all API requests.


    If you exceed the rate limit you will receive a HTTP 429 response with a
    JSON response body like this:


    ```

    {
      "success":false,
      "error":"API rate limit exceeded"
    }

    ```


    If you receive this response, you should refrain from making requests for
    5-10 seconds and then retry the request.


    Hologram's REST API provides methods to perform many requests in bulk. For
    example, you can change the data plans of multiple SIMs at once using
    https://dashboard.hologram.io/api/1/links/cellular/changeplan.


    If there is request you would like to make in bulk but cannot, please reach
    out to [support@hologram.io](mailto:support@hologram.io) for assistance.
  version: '1'
servers:
  - url: https://dashboard.hologram.io/api/1
    description: Hologram REST API v1
security: []
tags:
  - name: Devices
    description: Devices
  - name: SIM Configuration
    description: SIM Configuration
    x-group: SIM Configuration - Conductor
  - name: Organizations
    description: Organizations
  - name: Personal account
    description: Personal account
  - name: Async Change Requests
    description: Async Change Requests
paths:
  /simcards/configure:
    post:
      tags:
        - SIM Configuration
      summary: Apply a SIM configuration to one or more SIM cards
      description: >-
        Dispatches a configuration change to the specified SIM cards. Non-admin
        users may only target SIM cards they can access and configurations
        allowed by their plan.
      operationId: configureSimCards
      requestBody:
        required: true
        content:
          application/json:
            schema:
              required:
                - configuration_id
                - simcard_ids
              properties:
                configuration_id:
                  description: ID of the SIM configuration to apply
                  type: integer
                simcard_ids:
                  description: SIM card IDs to configure (max 250)
                  type: array
                  items:
                    type: integer
                immediate:
                  description: >-
                    Skip the configuration queue; by default operations are
                    queued at the time of the next usage update. If set and our
                    backend is too busy to process the request in realtime this
                    endpoint will return a 429 rate limit error until there is
                    space for the request.
                  type: boolean
                plan_id:
                  description: >-
                    Change the device plan simultaneously; requires zone and
                    orgid
                  type: integer
                zone:
                  description: Required when plan_id is provided
                  type: string
                orgid:
                  description: Required when plan_id is provided
                  type: integer
              type: object
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ConfigureSimCardsResponse'
        '400':
          description: >-
            Invalid configuration, inaccessible SIM cards, incompatible plan, or
            no valid devices after validation
        '401':
          description: Unauthorized
        '429':
          description: >-
            Immediate configuration temporarily unavailable due to eUICC queue
            backlog
      security:
        - apiKeyAuth: []
components:
  schemas:
    ConfigureSimCardsResponse:
      properties:
        success:
          $ref: '#/components/schemas/SuccessProperty'
        data:
          $ref: '#/components/schemas/ConfigureSimCardsData'
      type: object
    SuccessProperty:
      description: Indicates whether the request was successful.
      type: boolean
      example: true
    ConfigureSimCardsData:
      properties:
        requested_deviceids:
          description: Device IDs for which configuration was successfully dispatched
          type: array
          items:
            type: integer
        requested_simcardids:
          description: SIM card IDs for which configuration was successfully dispatched
          type: array
          items:
            type: integer
        async_request_id:
          description: Parent async change request tracking this configure-sim operation
          type: integer
        child_ids:
          description: IDs of per-device child async change requests under async_request_id
          type: array
          items:
            type: integer
        warnings:
          type: array
          items:
            type: string
      type: object
  securitySchemes:
    apiKeyAuth:
      type: http
      description: >-
        HTTP Basic authentication using API keys. Set the username to `apikey`
        and the password to your API key. You can find your API key on the
        Hologram Dashboard under Account Settings.
      scheme: basic

````